{{ $hugoLaunchVersion := float site.Params.hugoLaunchVersion }}
{{ $endpoints := dict
  "v3" (dict
    "url" "https://gitlab.com/api/v4/projects/51970333/registry/repositories/8244403/tags?per_page=100"
    "versionFilter" (dict
      "type" "newer-or-equal"
      "version" $hugoLaunchVersion
    ))
  "v2" (dict
    "url" "https://gitlab.com/api/v4/projects/1794617/registry/repositories/3631228/tags?per_page=100"
    "versionFilter" (dict
      "type" "newer"
      "majorVersion" 15
      "minorVersion" 6
    ))
  "v1" (dict
    "url" "https://gitlab.com/api/v4/projects/1794617/registry/repositories/631635/tags?per_page=100"
    "versionFilter" (dict
      "type" "older"
      "majorVersion" 15
      "minorVersion" 6
    ))
}}

{{ $endpointOrder := slice "v3" "v2" "v1" }}
{{ $hasError := false }}
{{ $responses := dict }}

<!-- Fetch all responses -->
{{ range $key := $endpointOrder }}
  {{ $endpoint := index $endpoints $key }}
  {{ $response := try (resources.GetRemote $endpoint.url) }}

  {{ if $response.Err }}
    {{ $hasError = true }}
  {{ else }}
    {{ $responses = merge $responses (dict $key $response.Value) }}
  {{ end }}
{{ end }}

{{ if $hasError }}
  <div class="docs-error-box">
    <div class="docs-error-icon"></div>
    <div>Archives list could not be loaded, please try again later.</div>
  </div>
{{ else }}
  <!-- Create a slice to collect ALL matching versions before rendering -->
  {{ $allVersions := slice }}

  {{ range $key := $endpointOrder }}
    {{ $response := index $responses $key }}
    {{ $endpoint := index $endpoints $key }}
    {{ $responseData := $response | transform.Unmarshal }}

    <!-- Get stable versions -->
    {{ $preSortedVersions := slice }}
    {{ range $responseData }}
      {{ if eq (partial "functions/is-stable-version" (dict "version" .name)) "true" }}
        {{ $preSortedVersions = $preSortedVersions | append .name }}
      {{ end }}
    {{ end }}

    <!-- Sort versions -->
    {{ $padded := apply $preSortedVersions "partial" "functions/padZeroPrefix.html" "." }}
    {{ $sorted := sort $padded "value" "desc" }}
    {{ $results := apply $sorted "partial" "functions/trimZeroPrefix.html" "." }}

    <!-- Create final slice with full version data and endpoint info -->
    {{ range $eachSortedVersion := $results }}
      {{ range $eachVersion := $responseData }}
        {{ if eq $eachSortedVersion $eachVersion.name }}
          <!-- Add endpoint information to version data -->
          {{ $versionWithEndpoint := merge $eachVersion (dict "endpoint" $key) }}
          {{ $allVersions = $allVersions | append $versionWithEndpoint }}
        {{ end }}
      {{ end }}
    {{ end }}
  {{ end }}

  <!-- Now sort ALL versions together -->
  {{ $paddedAll := slice }}
  {{ range $allVersions }}
    {{ $paddedName := partial "functions/padZeroPrefix.html" .name }}
    {{ $paddedVersion := merge . (dict "paddedName" $paddedName) }}
    {{ $paddedAll = $paddedAll | append $paddedVersion }}
  {{ end }}
  {{ $sortedAll := sort $paddedAll "paddedName" "desc" }}
  {{ $finalResults := $sortedAll }}

  <!-- Create a map to track rendered versions -->
  {{ $renderedVersions := dict }}

  <!-- Render all versions in correct order -->
  {{ range $finalResults }}
    {{ $version := .name }}
    {{ if not (isset $renderedVersions $version) }}
      {{ $splitStr := split .name "." }}
      {{ $majorVersion := cast.ToInt (index $splitStr 0) }}
      {{ $minorVersion := cast.ToInt (index $splitStr 1) }}

      {{ $endpoint := index $endpoints .endpoint }}
      {{ $filter := $endpoint.versionFilter }}
      {{ $shouldRender := false }}

      {{ if eq $filter.type "newer" }}
        {{ $shouldRender = or (and (eq $majorVersion $filter.majorVersion) (ge $minorVersion $filter.minorVersion)) (gt $majorVersion $filter.majorVersion) }}
      {{ else if eq $filter.type "older" }}
        {{ $shouldRender = or (lt $majorVersion $filter.majorVersion) (and (eq $majorVersion $filter.majorVersion) (lt $minorVersion $filter.minorVersion)) }}
      {{ else if eq $filter.type "newer-or-equal" }}
        {{ $filterVersion := split $filter.version "." }}
        {{ $filterMajor := cast.ToInt (index $filterVersion 0) }}
        {{ $filterMinor := cast.ToInt (index $filterVersion 1) }}
        {{ $shouldRender = or (gt $majorVersion $filterMajor) (and (eq $majorVersion $filterMajor) (ge $minorVersion $filterMinor)) }}
      {{ end }}

      {{ if $shouldRender }}
        {{- partial "archiveItem.html" . -}}
        {{ $renderedVersions = merge $renderedVersions (dict $version true) }}
      {{ end }}
    {{ end }}
  {{ end }}
{{ end }}
